#!/usr/bin/python
import cybro_scgi_server
import threading
import globals
import time
from profiling import threads_profiler

# -----------------------------------------------------------------------------
class DelayedShutDown(threading.Thread):
        
    def __init__(self,start_delay=1000,stop_delay=1000):
        self.__start_delay = start_delay
        self.__stop_delay = stop_delay
        threading.Thread.__init__(self)
        self.start()
    
    def run(self):
        time.sleep(self.__start_delay/1000.0)
        print "\n=========================== PROFILER START ======================================================\n"
        threads_profiler.profile_on()
        time.sleep(self.__stop_delay/1000.0)
        threads_profiler.profile_off()
        globals.ServerShutdownRequest = True

# -----------------------------------------------------------------------------
if __name__ == "__main__":
    shutDown = DelayedShutDown(100000,180000);
    cybro_scgi_server.CybroScgiServer().run()
    # profiles statistics
    print "\n".join(threads_profiler.get_profile_stats())
    # micro benchmark statistics (if any) 
    print "\n\n\n"+threads_profiler.timing_poool.get_stats()


