from django import template
from django.template.defaultfilters import stringfilter
import re
import project.main.object_factory

register = template.Library()


#--------------------------------------------------------------------------------------------------

def render_page(s, page_id):

    from project.main.models import Page, Template

    replaces = []

    update_period = 10000
    try:
        page = Page.objects.get(id = page_id)

        if page.update_period != None:
            update_period = page.update_period.get_period_ms()
    except:
        page = None

    #----------------------------------------------------------------------------------------------

    def parse_template_tag(match):

        params = match.group(1)

        p = re.compile(r'<name>(.*?)</name>', re.DOTALL | re.IGNORECASE)
        m = p.search(params)
        if m != None:
            try:
                template = Template.objects.get(name = m.group(1))

                p = re.compile(r'<search>(.*?)</search>.*?<replace>(.*?)</replace>', re.DOTALL | re.IGNORECASE)
                matches = p.findall(params)

                if matches:
                    for m in matches:
                        replaces.append((m[0], m[1]))
            except:
                return ""

            return template.content
        else:
            return ""

    #----------------------------------------------------------------------------------------------

    def parse_cybro_tag(match):

        params = match.group(1)

        p = re.compile(r'<type>(.*?)</type>', re.DOTALL | re.IGNORECASE)
        m = p.search(params)

        if m != None:
            object_type = m.group(1)
            obj = factory.create_object(object_type, params)
            if obj != None:
                return obj.create_object_html()

        return ""

    #----------------------------------------------------------------------------------------------

    factory = project.main.object_factory.ObjectFactory()

    p = re.compile(r'<template>(.*?)</template>', re.DOTALL | re.IGNORECASE)
    template_html = p.sub(parse_template_tag, s)

    for r in replaces:
        template_html = template_html.replace(r[0], r[1])

    p = re.compile(r'<cybro>(.*?)</cybro>', re.DOTALL | re.IGNORECASE)
    html = p.sub(parse_cybro_tag, template_html)

    return html + factory.create_html(update_period)

#--------------------------------------------------------------------------------------------------


render_page = stringfilter(render_page)
register.filter("render_page", render_page)

